--!parent
--!encoding=utf-8

--****************************************************************************
-- @file LSW CORE LIB: LAV
-- @author Valentin Schmidt
-- @version	0.1
-- @requires xtra("Lav")
--****************************************************************************

property ancestor

property $

property _handler
property _target

-- constants
property EVENT

property STATE_IDLE
property STATE_STOPPED
property STATE_PAUSED
property STATE_RUNNING
	
----------------------------------------
-- @constructor
----------------------------------------
on new (me, props)
	if $.OS="mac" then return FALSE
	$.loadXtras(me.libdir, ["LavXtra.x32"], [])
	
	if ilk(props)<>#propList then
		me.ancestor = xtra("Lav").new()
	else
		if voidP(props[#filterDir]) then props[#filterDir] = _movie.path&"filters"
		if voidP(props[#movieNum]) then props[#movieNum] = 1
		if voidP(props[#rect]) then 
			mr = _player.windowlist[props[#movieNum]].rect
			props[#rect] = rect(0, 0, mr.width, mr.height)
		end if
		if voidP(props[#eventCallback]) then
			me.ancestor = xtra("Lav").new(props[#filterDir], props[#movieNum], props[#rect])
		else
			$.import("detacher")
			if voidP(props[#eventTarget]) then
				props[#eventTarget] = _movie
			end if
			me._handler = props[#eventCallback]
			me._target = props[#eventTarget]
			me.ancestor = xtra("Lav").new(props[#filterDir], props[#movieNum], props[#rect], #_eventcallback, me)
		end if
	end if
	
	-- load constants
	me.loadEventConstants()
	
	me.STATE_IDLE = 0
	me.STATE_STOPPED = 1
	me.STATE_PAUSED = 2
	me.STATE_RUNNING = 3
	
	return me
end

----------------------------------------
-- @callback
----------------------------------------
on _eventcallback (me, evt, param1, param2)	
	if symbolP(me._handler) then
		me.$.detacher.detach(me._handler, me._target, evt, param1, param2)
	end if
end

----------------------------------------
--
----------------------------------------
on loadEventConstants (me)

	const = [:]

	const[#EC_ACTIVATE]=19
	const[#EC_BUFFERING_DATA]=17
	const[#EC_BUILT]=768
	const[#EC_CLOCK_CHANGED]=13
	const[#EC_CLOCK_UNSET]=81
	const[#EC_CODECAPI_EVENT]=87
	const[#EC_COMPLETE]=1
	const[#EC_DEVICE_LOST]=31
	const[#EC_DISPLAY_CHANGED]=22
	const[#EC_END_OF_SEGMENT]=28
	const[#EC_ERRORABORT]=3
	const[#EC_ERROR_STILLPLAYING]=8
	const[#EC_EXTDEVICE_MODE_CHANGE]=49
	const[#EC_FULLSCREEN_LOST]=18
	const[#EC_GRAPH_CHANGED]=80
	const[#EC_LENGTH_CHANGED]=30
	const[#EC_NEED_RESTART]=20
	const[#EC_NOTIFY_WINDOW]=25
	const[#EC_OLE_EVENT]=24
	const[#EC_OPENING_FILE]=16
	const[#EC_PALETTE_CHANGED]=9
	const[#EC_PAUSED]=14
	const[#EC_PREPROCESS_COMPLETE]=86
	const[#EC_QUALITY_CHANGE]=11
	const[#EC_REPAINT]=5
	const[#EC_SEGMENT_STARTED]=29
	const[#EC_SHUTTING_DOWN]=12
	const[#EC_SNDDEV_IN_ERROR]=512
	const[#EC_SNDDEV_OUT_ERROR]=513
	const[#EC_STARVATION]=23
	const[#EC_STATE_CHANGE]=50
	const[#EC_STEP_COMPLETE]=36
	const[#EC_STREAM_CONTROL_STARTED]=27
	const[#EC_STREAM_CONTROL_STOPPED]=26
	const[#EC_STREAM_ERROR_STILLPLAYING]=7
	const[#EC_STREAM_ERROR_STOPPED]=6
	const[#EC_SYSTEMBASE]=0
	const[#EC_TIME]=4
	const[#EC_TIMECODE_AVAILABLE]=48
	const[#EC_UNBUILT]=769
	const[#EC_USER]=32768
	const[#EC_USERABORT]=2
	const[#EC_VIDEO_SIZE_CHANGED]=10
	const[#EC_VMR_RECONNECTION_FAILED]=85
	const[#EC_VMR_RENDERDEVICE_SET]=83
	const[#EC_VMR_SURFACE_FLIPPED]=84
	const[#EC_WINDOW_DESTROYED]=21
	const[#EC_WMT_EVENT]=594
	const[#EC_WMT_INDEX_EVENT]=593

	me.EVENT = const
end
