--!parent
--!encoding=utf-8

global $

property pSprites
property pPlayHeadMouseDown
property pPlayHeadX
property pVideoOpen
property pDuration
property pStatus

property CHECK_PERIOD
property pTimer

----------------------------------------
--
----------------------------------------
on new me

	-- libs
	$.import("importer", ["bmp"])
	$.import("sprite")
	$.import("timer")

	me.pSprites = [:]

	names = ["play_btn_do","pause_btn","pause_btn_do","step_back_btn_do","step_fwd_btn_do","controller_left","controller_right"]

	rects = [:]
	rects["play_btn"] = rect(0, 240, 16, 256)

	rects["controller_left"] = rect(17, 240, 24, 256)
	rects["controller_right"] = rect(281, 240, 288, 256)
	rects["controller_bg"] = rect(24, 240, 281, 256)

	rects["playhead"] = rect(16, 241, 24, 255)

	rects["step_back_btn"] = rect(288, 240, 304, 256)
	rects["step_fwd_btn"] = rect(304, 240, 320, 256)

	-- controllerBg
	m = $.importer.load($.PATH&"resources\img\controller_bg.bmp")
	m.regpoint = point(0,0)
	r = rects["controller_bg"]
	s = $.sprite.make(m, [#rect:r], TRUE)
	s.addListener(#mouseDown, me, #controllerBgMouseDown)
	me.pSprites[#controllerBg] = s

	-- playBtn
	m = $.importer.load($.PATH&"resources\img\play_btn.bmp")
	m.regpoint = point(0,0)
	r = rects["play_btn"]
	s = $.sprite.make(m, [#rect:r], TRUE)
	s.addListener(#mouseDown, me, #playBtnMouseDown)
	s.addListener(#mouseUp, me, #playBtnMouseUp)
	s.addListener(#mouseUpOutside, me, #playBtnMouseUp)
	me.pSprites[#playBtn] = s

	repeat with n in names
		m = $.importer.load($.PATH&"resources\img\"&n&".bmp")
		m.name = n
		m.regpoint = point(0,0)
		if not voidP(rects[n]) then
			r = rects[n]
			s = $.sprite.make(m, [#rect:r])
			me.pSprites[n] = s
		end if
	end repeat

	-- stepBackBtn
	m = $.importer.load($.PATH&"resources\img\step_back_btn.bmp")
	m.regpoint = point(0,0)
	r = rects["step_back_btn"]
	s = $.sprite.make(m, [#rect:r], TRUE)
	s.addListener(#mouseDown, me, #stepBackBtnMouseDown)
	s.addListener(#mouseUp, me, #stepBackBtnMouseUp)
	s.addListener(#mouseUpOutside, me, #stepBackBtnMouseUp)
	me.pSprites[#stepBackBtn] = s

	-- stepFwdBtn
	m = $.importer.load($.PATH&"resources\img\step_fwd_btn.bmp")
	m.regpoint = point(0,0)
	r = rects["step_fwd_btn"]
	s = $.sprite.make(m, [#rect:r], TRUE)
	s.addListener(#mouseDown, me, #stepFwdBtnMouseDown)
	s.addListener(#mouseUp, me, #stepFwdBtnMouseUp)
	s.addListener(#mouseUpOutside, me, #stepFwdBtnMouseUp)
	me.pSprites[#stepFwdBtn] = s

	-- playHead
	m = $.importer.load($.PATH&"resources\img\playhead.bmp")
	m.regpoint = point(0,0)
	r = rects["playhead"]
	s = $.sprite.make(m, [#rect:r], TRUE)
	s.addListener(#mouseDown, me, #playHeadMouseDown)
	s.addListener(#mouseUp, me, #playHeadMouseUp)
	s.addListener(#mouseUpOutside, me, #playHeadMouseUp)
	me.pSprites[#playHead] = s

	-- setup timer
	me.CHECK_PERIOD = 100
	me.pTimer = $.timer.create(0, #slotCheck, me)

	return me
end

----------------------------------------
--
----------------------------------------
on windowResized (me)
	sr = _movie.stage.rect
	repeat with i = 1 to 7
		sprite(i).locV = sr.height - 28 - 8
	end repeat

	me.pSprites[#playHead].locV = me.pSprites[#playHead].locV+1

	me.pSprites[#controllerBg].width = sr.width - 63

	me.pSprites["controller_right"].locH= sr.width - 36 - 3

	-- step btns
	me.pSprites[#stepBackBtn].locH= sr.width - 24 - 8
	me.pSprites[#stepFwdBtn].locH = sr.width - 8 - 8
end

----------------------------------------
-- PLAYHEAD
----------------------------------------
on playHeadMouseDown me
	if not me.pVideoOpen then return

	me.pPlayHeadMouseDown = 1
	me.pPlayHeadX = _mouse.mouseH - me.pSprites[#playHead].locH
end

----------------------------------------
--
----------------------------------------
on playHeadMouseUp me
	if not me.pVideoOpen then return
	me.pPlayHeadMouseDown=0
end

----------------------------------------
-- PLAYBTN
----------------------------------------
on playBtnMouseDown me
	stat =	$.lav.ds_get_status()
	if stat = $.lav.STATE_IDLE then return

	if stat=$.lav.STATE_RUNNING then
		me.pSprites[#playBtn].member = member("pause_btn_do")
	else
		me.pSprites[#playBtn].member = member("play_btn_do")
	end if
end

----------------------------------------
--
----------------------------------------
on playBtnMouseUp me
	stat = $.lav.ds_get_status()
	if stat = $.lav.STATE_IDLE then return

	if stat=$.lav.STATE_RUNNING then
		$.lav.ds_pause()
		me.pSprites[#playBtn].member = member("play_btn")
	else
		$.lav.ds_play()
		me.pSprites[#playBtn].member = member("pause_btn")
	end if
end

----------------------------------------
-- STEPBACKBTN
----------------------------------------
on stepBackBtnMouseDown me
	me.pSprites[#stepBackBtn].member = member("step_back_btn_do")

	stat = $.lav.ds_get_status()
	if stat = $.lav.STATE_IDLE then return

	$.lav.ds_step_backwards()
end

on stepBackBtnMouseUp me
	me.pSprites[#stepBackBtn].member = member("step_back_btn")
end

----------------------------------------
-- STEPFWDBTN
----------------------------------------
on stepFwdBtnMouseDown me
	me.pSprites[#stepFwdBtn].member = member("step_fwd_btn_do")

	stat = $.lav.ds_get_status()
	if stat = $.lav.STATE_IDLE then return

	$.lav.ds_step_forward()
end

on stepFwdBtnMouseUp me
	me.pSprites[#stepFwdBtn].member = member("step_fwd_btn")
end

----------------------------------------
-- controller_bg
----------------------------------------
on controllerBgMouseDown me
	if not me.pVideoOpen or me.pDuration=0 then return

	x = _mouse.mouseH - 3
	me.pSprites[#playHead].locH = x

	tMin = me.pSprites[#controllerBg].left-8
	tMax = me.pSprites[#controllerBg].right -- 340-12
	t = integer(me.pDuration*(x-tMin)/(tMax-tMin))
	$.lav.ds_set_param("time", t)
end

--**************************************
-- EVENTS
--**************************************

----------------------------------------
--
----------------------------------------
on videoOpened me
	-- playBtn
	if $.lav.ds_get_status()=$.lav.STATE_RUNNING then me.pSprites[#playBtn].member = member("pause_btn")

	-- playHead
	me.pSprites[#playHead].locH = me.pSprites[#controllerBg].left-8

	info = $.lav.ds_get_media_info()
	me.pDuration = float(info["duration"])
	if me.pDuration>0 then
		me.pVideoOpen = 1
		me.pTimer.period = me.CHECK_PERIOD
	else
		me.pVideoOpen = 0
		me.pTimer.period = 0
	end if
end

----------------------------------------
--
----------------------------------------
on videoStopped me
	me.pSprites[#playBtn].member = member("play_btn")
end

----------------------------------------
--
----------------------------------------
on videoClosed me
	-- playHead
	me.pSprites[#playHead].locH = me.pSprites[#controllerBg].left-8

	me.pVideoOpen = 0
	me.pDuration = 0
	me.pTimer.period = 0
end

----------------------------------------
--
----------------------------------------
on slotCheck me
	tMin = me.pSprites[#controllerBg].left-8
	tMax = me.pSprites[#controllerBg].right -- 340-12

	if me.pPlayHeadMouseDown then
		x = min(tMax, max(tMin, _mouse.mouseH - me.pPlayHeadX))
		me.pSprites[#playHead].locH = x
		t = integer(me.pDuration*(x-tMin)/(tMax-tMin))
		$.lav.ds_set_param("time", t)

	else if me.pVideoOpen and me.pDuration>0 then
		t =	$.lav.ds_get_param("time")
		me.pSprites[#playHead].locH = tMin + (tMax-tMin) * t/me.pDuration
	end if
end
