--!movie
--!encoding=utf-8

global $

global gMenuObj
global gControllerObj
global gVideoRect
global gPrefs
global gLastToggleFullscreenKey

----------------------------------------
-- FILE
----------------------------------------

----------------------------------------
--
----------------------------------------
on mOpenFile
	fmask = ""
	put "Video Files,*.avi;*.flv;*.mov;*.mp4;*.mpg;*.vob;*.wmv" after fmask
	put ",Audio Files,*.aac;*.ac3;*.mp3;*.ogg;*.wav;*.wma" after fmask
	put ",Image Files,*.bmp;*.jpg;*.png" after fmask
	put ",All Files,*.*" after fmask
	fn = $.file.selectFileOpen("Open File", fmask, "")
	if not voidP(fn) then openFile(fn)
end

----------------------------------------
-- *.srt, *.sub, *.ssa, *.ass
----------------------------------------
on mLoadSubs
	fmask = ""
	put "Subtitles Files (*.srt *.sub *.ssa *.ass),*.srt;*.sub;*.ssa;*.ass" after fmask
	put ",All Files,*.*" after fmask
	fn = $.file.selectFileOpen("Open File", fmask, "")
	if not voidP(fn) then loadSubs(fn)
end

----------------------------------------
--
----------------------------------------
on mClose()
	$.lav.ds_close()
	gControllerObj.videoClosed()
end

----------------------------------------
--
----------------------------------------
on mShowInfo()
	info = $.lav.ds_get_media_info()
	if not listP(info) then return
	cnt = count(info)
	s=""
	repeat with i = 1 to cnt
		put info.getPropAt(i)&": "&info[i]&RETURN after s
	end repeat
	alert(s)
end

----------------------------------------
--
----------------------------------------
on mSaveImage
	fn = $.file.selectFileSave ("Save Current Frame As Bitmap File", "Bitmap Files (*.bmp),*.bmp", "frame.bmp")
	if voidP(fn) then return
	$.lav.ds_grab_image(["bmpfile": fn])
end

----------------------------------------
--
----------------------------------------
on mQuit
	myStopMovie()
	_player.quit()
end

----------------------------------------
-- VIEW
----------------------------------------

----------------------------------------
--
----------------------------------------
on mToggleKeepRatio
	gPrefs["keepaspectratio"] = not(gPrefs["keepaspectratio"])
	m = gMenuObj
	m.setItemCheckMark ("View", "Keep Aspect Ratio", gPrefs["keepaspectratio"])
	$.lav.ds_set_param("keepaspectratio", gPrefs["keepaspectratio"])
end

----------------------------------------
--
----------------------------------------
on mToggleResizeWindow
	gPrefs["resize_window"] = not(gPrefs["resize_window"])
	m = gMenuObj
	m.setItemCheckMark ("View", "Resize Window to Video", gPrefs["resize_window"])

	if not(gPrefs["resize_window"]) or $.lav.ds_get_status()=$.lav.STATE_IDLE then return

	info = $.lav.ds_get_media_info()
	if not listP(info) then return
	if info["width"]>0 then
		_movie.stage.rect = rect(0,0,info["width"],info["height"]+37)
		centerWindow()
	end if
end

----------------------------------------
--
----------------------------------------
on mToggleFullscreenKey (obj)
	ms = the milliseconds
	if ms-gLastToggleFullscreenKey>500 then
		mToggleFullscreen()
	end if
	gLastToggleFullscreenKey = ms
end

----------------------------------------
--
----------------------------------------
on mToggleFullscreen
	gPrefs["fullscreen"] = not(gPrefs["fullscreen"])

	repeat with i = 1 to $.sprite._nextChannel-1
		sprite(i).visible = not gPrefs["fullscreen"]
	end repeat
	if gPrefs["fullscreen"] then
		installMenu 0
	else
		gMenuObj.update()
	end if

	$.lav.ds_set_param("fullscreen", gPrefs["fullscreen"])

	if $.lav.ds_get_status()<>$.lav.STATE_RUNNING then
		$.lav.ds_step_forward(0)
	end if
end

----------------------------------------
-- PLAY
----------------------------------------

----------------------------------------
--
----------------------------------------
on mSetRate (n)
	rates = ["0.5", "1", "2"]
	hr = $.lav.ds_set_param("rate", float(rates[n]))
	put hr

	m = gMenuObj
	repeat with i = 1 to 3
		m.setItemCheckMark ("Play", "Rate *" && rates[i], (i=n))
	end repeat
end

----------------------------------------
--
----------------------------------------
on mToggleLoop
	gPrefs["loop"] = not(gPrefs["loop"])
	$.lav.ds_set_param("loop", gPrefs["loop"])

	m = gMenuObj
	m.setItemCheckMark ("Play", "Loop", gPrefs["loop"])
end

----------------------------------------
-- AUDIO
----------------------------------------

----------------------------------------
--
----------------------------------------
on mSetVolume (v)
	-- 0..10 --> -10000..0

	-- TO DO: use logarithmic values!
	--	vol = (v-10)*1000.0
	--	vol = (vol/10000 *vol/10000 *vol)
	--	vol = integer(vol)
	--	put vol

	if v=0 then vol=-10000
	else vol = (v-10)*300

	$.lav.ds_set_param("volume", vol)

	m = gMenuObj
	repeat with i = 10 down to 0
		m.setItemCheckMark ("Audio", "Volume" && i, (i=v))
	end repeat
end

----------------------------------------
--
----------------------------------------
on mSetBalance (v)
	-- -5..5 --> -10,000..10,000.
	$.lav.ds_set_param("balance", v*2000)

	m = gMenuObj
	repeat with i = -5 to 5
		m.setItemCheckMark ("Audio", "Balance" && i, (i=v))
	end repeat
end

----------------------------------------
-- HELP
----------------------------------------

----------------------------------------
--
----------------------------------------
on mAbout()
	alert(_movie.stage.title & RETURN&RETURN&"© 2019 Valentin Schmidt")
end

