--!parent
--!encoding=utf-8

property pData
property pMem

----------------------------------------
--
----------------------------------------
on new me
	me.pData = [:]
	me.pMem = new(#field)
	return me
end

----------------------------------------
--
----------------------------------------
on init me
	me.pData = [:]
end

----------------------------------------
--
----------------------------------------
on update (me)
	s = ""
	cnt = count(pData)
	repeat with i = 1 to cnt

		put "menu: "&pData.getPropAt(i)&RETURN after s
		m = pData[i]
		repeat with tItem in m
			if tItem["name"]="-" then
				put "(-|"&RETURN after s
			else
				if tItem["enabled"]=0 then put "(" after s
				if tItem["checkMark"]=1 then put "! " after s
				put tItem["name"] after s
				if string(tItem["letter"])<>"" then put "/"&tItem["letter"] after s
				put "|"&tItem["handler"]&RETURN after s
			end if
		end repeat
	end repeat

	pMem.text = s
	installMenu pMem
end

----------------------------------------
--
----------------------------------------
on addMenu (me, tMenuName)
	me.pData.addProp(tMenuName, [])
end

----------------------------------------
--
----------------------------------------
on addItem (me, tMenuName, tItem, tUpdateFlag)
	if voidP(tItem["enabled"]) then tItem["enabled"]=1
	if voidP(tItem["checkMark"]) then tItem["checkMark"]=0
	me.pData[tMenuName].add(tItem)
	if tUpdateFlag then me.update()
end

----------------------------------------
--
----------------------------------------
on addSep (me, tMenuName)
	me.addItem (tMenuName, ["name": "-"])
end

----------------------------------------
--
----------------------------------------
on setItemEnabledEnabled (me, tMenu, tItemName, flag)
	cnt = pData[tMenu].count
	repeat with i = 1 to cnt
		if pData[tMenu][i]["name"]=tItemName then
			pData[tMenu][i]["enabled"]=flag
			_menuBar.menu[tMenu].item[i].enabled = flag
			exit repeat
		end if
	end repeat
end

----------------------------------------
--
----------------------------------------
on setItemCheckMark (me, tMenu, tItemName, flag)
	cnt = pData[tMenu].count
	repeat with i = 1 to cnt
		if pData[tMenu][i]["name"]=tItemName then
			pData[tMenu][i]["checkMark"]=flag
			_menuBar.menu[tMenu].item[i].checkMark = flag
			exit repeat
		end if
	end repeat
end

